/* Generated by wayland-scanner 1.23.0 */

#ifndef WLMAKER_ICON_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define WLMAKER_ICON_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_wlmaker_icon_unstable_v1 The wlmaker_icon_unstable_v1 protocol
 * @section page_ifaces_wlmaker_icon_unstable_v1 Interfaces
 * - @subpage page_iface_zwlmaker_icon_manager_v1 - Icon Manager
 * - @subpage page_iface_zwlmaker_toplevel_icon_v1 - Toplevel Icon
 * @section page_copyright_wlmaker_icon_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </pre>
 */
struct wl_surface;
struct xdg_toplevel;
struct zwlmaker_icon_manager_v1;
struct zwlmaker_toplevel_icon_v1;

#ifndef ZWLMAKER_ICON_MANAGER_V1_INTERFACE
#define ZWLMAKER_ICON_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zwlmaker_icon_manager_v1 zwlmaker_icon_manager_v1
 * @section page_iface_zwlmaker_icon_manager_v1_desc Description
 *
 * This interface permits clients to register an icon surface for a
 * toplevel. Compositors can use this to present the toplevel in
 * iconified state.
 * @section page_iface_zwlmaker_icon_manager_v1_api API
 * See @ref iface_zwlmaker_icon_manager_v1.
 */
/**
 * @defgroup iface_zwlmaker_icon_manager_v1 The zwlmaker_icon_manager_v1 interface
 *
 * This interface permits clients to register an icon surface for a
 * toplevel. Compositors can use this to present the toplevel in
 * iconified state.
 */
extern const struct wl_interface zwlmaker_icon_manager_v1_interface;
#endif
#ifndef ZWLMAKER_TOPLEVEL_ICON_V1_INTERFACE
#define ZWLMAKER_TOPLEVEL_ICON_V1_INTERFACE
/**
 * @page page_iface_zwlmaker_toplevel_icon_v1 zwlmaker_toplevel_icon_v1
 * @section page_iface_zwlmaker_toplevel_icon_v1_desc Description
 *
 * This interface permits clients to configure a surface representing
 * the toplevel in iconified state.
 * @section page_iface_zwlmaker_toplevel_icon_v1_api API
 * See @ref iface_zwlmaker_toplevel_icon_v1.
 */
/**
 * @defgroup iface_zwlmaker_toplevel_icon_v1 The zwlmaker_toplevel_icon_v1 interface
 *
 * This interface permits clients to configure a surface representing
 * the toplevel in iconified state.
 */
extern const struct wl_interface zwlmaker_toplevel_icon_v1_interface;
#endif

#define ZWLMAKER_ICON_MANAGER_V1_DESTROY 0
#define ZWLMAKER_ICON_MANAGER_V1_GET_TOPLEVEL_ICON 1


/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 */
#define ZWLMAKER_ICON_MANAGER_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 */
#define ZWLMAKER_ICON_MANAGER_V1_GET_TOPLEVEL_ICON_SINCE_VERSION 1

/** @ingroup iface_zwlmaker_icon_manager_v1 */
static inline void
zwlmaker_icon_manager_v1_set_user_data(struct zwlmaker_icon_manager_v1 *zwlmaker_icon_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwlmaker_icon_manager_v1, user_data);
}

/** @ingroup iface_zwlmaker_icon_manager_v1 */
static inline void *
zwlmaker_icon_manager_v1_get_user_data(struct zwlmaker_icon_manager_v1 *zwlmaker_icon_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwlmaker_icon_manager_v1);
}

static inline uint32_t
zwlmaker_icon_manager_v1_get_version(struct zwlmaker_icon_manager_v1 *zwlmaker_icon_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwlmaker_icon_manager_v1);
}

/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 *
 * Destroys the Toplevel Icon Manager.
 */
static inline void
zwlmaker_icon_manager_v1_destroy(struct zwlmaker_icon_manager_v1 *zwlmaker_icon_manager_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwlmaker_icon_manager_v1,
			 ZWLMAKER_ICON_MANAGER_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zwlmaker_icon_manager_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 *
 * Creates a new icon object associated with the given XDG toplevel.
 */
static inline struct zwlmaker_toplevel_icon_v1 *
zwlmaker_icon_manager_v1_get_toplevel_icon(struct zwlmaker_icon_manager_v1 *zwlmaker_icon_manager_v1, struct xdg_toplevel *toplevel, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zwlmaker_icon_manager_v1,
			 ZWLMAKER_ICON_MANAGER_V1_GET_TOPLEVEL_ICON, &zwlmaker_toplevel_icon_v1_interface, wl_proxy_get_version((struct wl_proxy *) zwlmaker_icon_manager_v1), 0, NULL, toplevel, surface);

	return (struct zwlmaker_toplevel_icon_v1 *) id;
}

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 * @struct zwlmaker_toplevel_icon_v1_listener
 */
struct zwlmaker_toplevel_icon_v1_listener {
	/**
	 * Sets the icon surface size.
	 *
	 * Suggests size for the icon surface.
	 *
	 * After creating the toplevel icon, the client is required to
	 * commit a surface with a NULL buffer. This will trigger the
	 * `configure` event, informing the client of the recommended icon
	 * size.
	 *
	 * The client may chose a different icon size. The compositor may
	 * chose to scale icons of non-recommended size as desired.
	 *
	 * Once received, the client must send an `ack_configure` with the
	 * serial.
	 *
	 * Once done, the client may proceed committring surfaces with
	 * attached buffers.
	 * @param width New width of the surface
	 * @param height New height of the surface
	 * @param serial the serial of the user event
	 */
	void (*configure)(void *data,
			  struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1,
			  int32_t width,
			  int32_t height,
			  uint32_t serial);
};

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
static inline int
zwlmaker_toplevel_icon_v1_add_listener(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1,
				       const struct zwlmaker_toplevel_icon_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zwlmaker_toplevel_icon_v1,
				     (void (**)(void)) listener, data);
}

#define ZWLMAKER_TOPLEVEL_ICON_V1_DESTROY 0
#define ZWLMAKER_TOPLEVEL_ICON_V1_ACK_CONFIGURE 1

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_CONFIGURE_SINCE_VERSION 1

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_ACK_CONFIGURE_SINCE_VERSION 1

/** @ingroup iface_zwlmaker_toplevel_icon_v1 */
static inline void
zwlmaker_toplevel_icon_v1_set_user_data(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwlmaker_toplevel_icon_v1, user_data);
}

/** @ingroup iface_zwlmaker_toplevel_icon_v1 */
static inline void *
zwlmaker_toplevel_icon_v1_get_user_data(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwlmaker_toplevel_icon_v1);
}

static inline uint32_t
zwlmaker_toplevel_icon_v1_get_version(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwlmaker_toplevel_icon_v1);
}

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 *
 * Destroys the Toplevel Icon.
 */
static inline void
zwlmaker_toplevel_icon_v1_destroy(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwlmaker_toplevel_icon_v1,
			 ZWLMAKER_TOPLEVEL_ICON_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zwlmaker_toplevel_icon_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 *
 * Acknowledges configuration sequence.
 */
static inline void
zwlmaker_toplevel_icon_v1_ack_configure(struct zwlmaker_toplevel_icon_v1 *zwlmaker_toplevel_icon_v1, uint32_t serial)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwlmaker_toplevel_icon_v1,
			 ZWLMAKER_TOPLEVEL_ICON_V1_ACK_CONFIGURE, NULL, wl_proxy_get_version((struct wl_proxy *) zwlmaker_toplevel_icon_v1), 0, serial);
}

#ifdef  __cplusplus
}
#endif

#endif
